/* /////////////////////////////////////////////////////////////////////////////
 * File:        message_block_sequence_test.cpp
 *
 * Purpose:     Implementation file for the message_block_sequence_test project.
 *
 * Created:     15th September 2004
 * Updated:     17th May 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2004, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */


/* STLSoft Header Files */
#include <stlsoft.h>

/* ACESTL Header Files */
#include <acestl/acestl.hpp>
#include <acestl/message_queue_sequence.hpp>

/* Standard C++ Header Files */
#include <algorithm>
#if defined(__DMC__)
# include <iostream.h>
#else /* ? __DMC__ */
# include <iostream>

using std::cerr;
using std::cin;
using std::cout;
using std::endl;
#endif /* __DMC__ */
#include <vector>

/* /////////////////////////////////////////////////////////////////////////////
 * Functions
 */

inline ACE_Message_Block *new_ACE_Message_Block(char const *s, size_t n)
{
	ACE_Message_Block	*mb = new ACE_Message_Block(s, n);

	mb->wr_ptr(n);

	return mb;
}

inline ACE_Message_Block *new_ACE_Message_Block(char const *s, size_t n, size_t o)
{
	ACE_Message_Block	*mb = new ACE_Message_Block(s, n);

	mb->rd_ptr(n);
	mb->wr_ptr(n + o);

	return mb;
}

/* ////////////////////////////////////////////////////////////////////////// */

int main(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	cout << "message_block_sequence_test: " << __STLSOFT_COMPILER_LABEL_STRING << endl;
#endif /* debug */

	/* . */
	ACE_Message_Queue<ACE_NULL_SYNCH>	mq;
	ACE_Time_Value						nowait(ACE_OS::gettimeofday());

	mq.enqueue_tail(new_ACE_Message_Block("Hello ", 6), &nowait);
	mq.enqueue_tail(new_ACE_Message_Block("", 0), &nowait);
	mq.enqueue_tail(new_ACE_Message_Block("Hello M", 6, 1), &nowait);
	mq.enqueue_tail(new_ACE_Message_Block("atty!", 5), &nowait);

	acestl::message_queue_sequence<ACE_NULL_SYNCH>	mqs(mq);

	stlsoft_assert(mqs.size() == 12);

	std::vector<char>	v;

	std::copy(mqs.begin(), mqs.end(), std::ostream_iterator<char>(std::cout));
	std::cout << std::endl;

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
