/* /////////////////////////////////////////////////////////////////////////////
 * File:        allocator_test_2.cpp
 *
 * Purpose:     Implementation file for the allocator_test_2 project.
 *
 * Created:     20th August 2003
 * Updated:     30th May 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2003, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2003
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software.
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage.
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission.
 *
 * ////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>

#include <stlsoft.h>

#include <stlsoft_malloc_allocator.h>
#include <stlsoft_new_allocator.h>

stlsoft_ns_using(malloc_allocator)
stlsoft_ns_using(new_allocator)

#include <map>

stlsoft_ns_using_std(less)
stlsoft_ns_using_std(map)
stlsoft_ns_using_std(pair)

/* ////////////////////////////////////////////////////////////////////////// */

int main(int /* argc */, char ** /*argv*/)
{
	puts("allocator_test_2: " __STLSOFT_COMPILER_LABEL_STRING);

	/* . */
#ifdef __STLSOFT_CF_ALLOCATOR_CHARALLOC_METHOD // Just borrowing this, since it means VC6 & prior libs (perhaps with Intel compiler)
	typedef	malloc_allocator<int>					malloc_int_map_ator_t;
	typedef	new_allocator<int>						new_int_map_ator_t;
#else
	typedef	malloc_allocator<pair<const int, int> >	malloc_int_map_ator_t;
	typedef	new_allocator<pair<const int, int> >	new_int_map_ator_t;
#endif /* __STLSOFT_CF_ALLOCATOR_CHARALLOC_METHOD */

#if 0
	typedef	map<int, int, less<int>, new_int_map_ator_t >		int_to_int_map_t;
#else
	typedef	map<int, int, less<int>, malloc_int_map_ator_t >	int_to_int_map_t;
#endif /* 0 */

	int_to_int_map_t	m;

	m[1] = 1;
	m[2] = 1;
	m[3] = 2;

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
