/* /////////////////////////////////////////////////////////////////////////////
 * File:        contract_violation_exception_test.cpp
 *
 * Purpose:     Implementation file for the contract_violation_exception_test project.
 *
 * Created:     12th October 2004
 * Updated:     17th October 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2004, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>
#include <stlsoft/contract_violation.hpp>

/* Standard C Header Files */

/* Standard C++ Header Files */
#include <exception>
#include <iostream>

using std::cerr;
using std::cin;
using std::cout;
using std::endl;

/* /////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

#if (   defined(WIN32) || \
        defined(_WIN32)) && \
    !defined(_INC_WINDOWS)
extern "C" void __stdcall Sleep(unsigned long);
#endif /* WIN32 */

/* ////////////////////////////////////////////////////////////////////////// */

void contract_handler()
{
	cerr << "A contract was violated" << endl;

	exit(1);
}

int main_(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	cout << "contract_violation_exception_test: " << __STLSOFT_COMPILER_LABEL_STRING << endl;
#endif /* debug */

	/* . */
	stlsoft::contract_violation	*px;

	try
	{
		try
		{
			throw stlsoft::contract_violation(contract_handler);
		}
#if 0
		catch(stlsoft::contract_violation &x)
#else /* ? 0 */
		catch(std::exception x)
#endif /* 0 */
		{
			cout << "Caught the contract_violation exception: \"" << x.what() << "\" - rethrowing" << endl;

			throw;
		}
	}
#if 0
	catch(stlsoft::contract_violation &x)
	{
		cout << x.what() << endl;
	}
#endif /* 0 */
	catch(std::exception &x)
	{
		px = ::new stlsoft::contract_violation(static_cast<stlsoft::contract_violation&>(x));

		cout << "Caught the contract_violation exception: \"" << x.what() << "\"" << endl;

//		exit(1);
	}

	delete px;

	cout << "Something naughty has caught the exception" << endl;

    return 0;
}

int main(int argc, char *argv[])
{
	try
	{
		return main_(argc, argv);
	}
	catch(std::exception &x)
	{
		cerr << "Unhandled error: " << x.what() << endl;
	}
	catch(...)
	{
		cerr << "Unhandled unknown error" << endl;
	}

	return EXIT_FAILURE;
}

/* ////////////////////////////////////////////////////////////////////////// */
