/* /////////////////////////////////////////////////////////////////////////////
 * File:        has_member_type_test.cpp
 *
 * Purpose:     Implementation file for the has_member_type_test project.
 *
 * Created:     8th February 2004
 * Updated:     22nd April 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2004, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software.
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage.
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission.
 *
 * ////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>

#define _STLSOFT_NO_NAMESPACE

#include <stlsoft.h>
#include <stlsoft_meta.h>
#include <stlsoft_iterator.h>

/* ////////////////////////////////////////////////////////////////////////// */

#if (   defined(WIN32) || \
        defined(_WIN32)) && \
    !defined(_INC_WINDOWS)
extern "C" void __stdcall Sleep(unsigned long);
#endif /* WIN32 */

/* ////////////////////////////////////////////////////////////////////////// */

// These are the sample structures that are wrong!

template <typename T, typename P>
struct pointer_struct
{
    typedef T       value_type;
    typedef P       pointer;
};

template <typename T, typename P>
struct pointer_type_struct
{
    typedef T       value_type;
    typedef P       pointer_type;
};

/* ////////////////////////////////////////////////////////////////////////// */

//#define USE_PST

template <typename T, typename P>
struct iterator_base_
#ifdef USE_PST
    : public pointer_type_struct<T, P>
#else /* ? USE_PST */
    : public pointer_struct<T, P>
#endif /* USE_PST */
{
#ifdef USE_PST
    typedef pointer_type_struct<T, P>   parent_class_type;
#else /* ? USE_PST */
    typedef pointer_struct<T, P>        parent_class_type;
#endif /* USE_PST */
	typedef T							value_type;

    enum { has_member_pointer       =   0 != has_pointer<parent_class_type>::value };
    enum { has_member_pointer_type  =   0 != has_pointer_type<parent_class_type>::value };

    typedef ss_typename_type_k select_first_type<   ss_typename_type_k fixer_pointer_type<parent_class_type, has_member_pointer_type>::pointer
												,   ss_typename_type_k fixer_pointer<parent_class_type, has_member_pointer>::pointer
												,   has_member_pointer_type
												>::type             pointer;
};


/* ////////////////////////////////////////////////////////////////////////// */

int main(int /* argc */, char ** /*argv*/)
{
#if 0
    ::Sleep(100000);
#endif /* 0 */

    puts("has_member_type_test: " __STLSOFT_COMPILER_LABEL_STRING);

	{
		typedef iterator_base<stlsoft_ns_qual_std(input_iterator_tag), char, ptrdiff_t, char *, char &>	it_t_;

		it_t_	t2;

		printf("it_t_::base has its own pointer: %d\n", has_pointer<it_t_::parent_class_type>::value);
		printf("it_t_::base has its own pointer_type: %d\n", has_pointer_type<it_t_::parent_class_type>::value);
		printf("it_t_ has its own pointer: %d\n", has_pointer<it_t_>::value);
		printf("it_t_ has its own pointer_type: %d\n", has_pointer_type<it_t_>::value);

		it_t_::value_type	v	=	0;
//		it_t_::pointer		p	=	&v;
//		it_t_::reference	r	=	v;
	}

    /* . */
	{
		typedef iterator_base_<int, int const *>        it_t;

		it_t::value_type	v	=	0;
		it_t::value_type	*p1	=	&v;
		it_t::pointer		p2	=	&v;

		printf("it_t base has pointer: %d\n", it_t::has_member_pointer);
		printf("it_t base has pointer_type: %d\n", it_t::has_member_pointer_type);
		printf("it_t has its own pointer: %d\n", has_pointer<it_t>::value);
		printf("it_t has its own pointer_type: %d\n", has_pointer_type<it_t>::value);
	}

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
