/* /////////////////////////////////////////////////////////////////////////////
 * File:        options_verifier_test.cpp
 *
 * Purpose:     Implementation file for the options_verifier_test project.
 *
 * Created:     13th December 2004
 * Updated:     13th December 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2004, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>

#include <stlsoft/options_verifier.hpp>


/* Standard C Header Files */
#include <stdlib.h>

/* Standard C++ Header Files */
#include <iostream>
#include <string>

/* /////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

#if (   defined(WIN32) || \
        defined(_WIN32)) && \
    !defined(_INC_WINDOWS)
extern "C" void __stdcall Sleep(unsigned long);
#endif /* WIN32 */

/* ////////////////////////////////////////////////////////////////////////// */

int main_(int /* argc */, char * /* argv */[])
{
#if 0
	::Sleep(100000);
#endif /* 0 */

	typedef ::std::string	string_t;

	string_t	s	=	"";
	string_t	o1	=	"A";
	string_t	o3	=	"C";

	try
	{
		::stlsoft::verify_options(s, "Invalid value"), "A", "B";

		::stlsoft::verify_options(s, "Invalid value") == o1 || o3;

		::stlsoft::verify_options(s, "Invalid value") == o1 || "B" || o3;

//		::stlsoft::verify_options(s, "Invalid value") == o1 || "B" == o3;

//		::stlsoft::verify_options(s, "Invalid value") == o1 == "B" == o3;
//		::stlsoft::verify_options(s, "Invalid value") || o1 == o3;

//		::stlsoft::verify_options(10, "blah") || 100 == 200;

	}
	catch(std::exception &x)
	{
		std::cout << "Exception: " << x.what() << std::endl;
	}

    return EXIT_SUCCESS;
}

/* ////////////////////////////////////////////////////////////////////////// */

int main(int argc, char *argv[])
{
	try
	{
		return main_(argc, argv);
	}
	catch(std::exception &x)
	{
		fprintf(stderr, "Unhandled error: %s\n", x.what());
	}
	catch(...)
	{
		fprintf(stderr, "Unhandled unknown error\n");
	}

	return EXIT_FAILURE;
}

/* ////////////////////////////////////////////////////////////////////////// */
