/* /////////////////////////////////////////////////////////////////////////////
 * File:        proxy_pointer_test.cpp
 *
 * Purpose:     Implementation file for the proxy_pointer_test project.
 *
 * Created:     24th October 2003
 * Updated:     22nd April 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2003, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2003
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software.
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage.
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission.
 *
 * ////////////////////////////////////////////////////////////////////////// */

#include <stdio.h>

#include <stlsoft.h>
#include <stlsoft_proxy_ptr.h>

stlsoft_ns_using(proxy_ptr)

/* ////////////////////////////////////////////////////////////////////////// */

template <class P>
void pointer_test(P &p)
{
	P	p2(p);
	P	p3 = p;

	p2 = p;

	sizeof(*p);
}

/* ////////////////////////////////////////////////////////////////////////// */

int main(int /* argc */, char ** /*argv*/)
{
	puts("proxy_pointer_test: " __STLSOFT_COMPILER_LABEL_STRING);

	/* . */
	int					i	=	10l;
	int					bi	=	202;
	int					*pi(&i);
	proxy_ptr<int>	bpi(&bi);

	stlsoft_assert(i == *pi);
	stlsoft_assert(bi == *bpi);

	pointer_test(pi);
	pointer_test(bpi);

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
