/* /////////////////////////////////////////////////////////////////////////////
 * File:        tokeniser_functions_test.cpp
 *
 * Purpose:     Implementation file for the tokeniser_functions_test project.
 *
 * Created:     5th May 2005
 * Updated:     5th May 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright 1999-2005, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2005
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>
#include <stlsoft/tokeniser_functions.hpp>

/* Standard C Header Files */
#include <stdio.h>

/* Standard C++ Header Files */
#include <exception>

#ifdef __WATCOMC__
namespace std
{
	using ::exception;
}
#endif /* __WATCOMC__ */


/* /////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

#if (   defined(WIN32) || \
        defined(_WIN32)) && \
    !defined(_INC_WINDOWS)
extern "C" void __stdcall Sleep(unsigned long);
#endif /* WIN32 */


/* ////////////////////////////////////////////////////////////////////////// */

static int main_(int /* argc */, char ** /*argv*/)
{
#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	puts("tokeniser_functions_test: " __STLSOFT_COMPILER_LABEL_STRING);
#endif /* debug */

	/* . */
	{
		static const char	patterns[]	=	";;*.zip;*.html;;*.exe;;*.pdf;";
		char const			*p0			=	&patterns[0];
		char const			*p1			=	&patterns[0];

		printf("\npatterns: %s\n", patterns);
		{ for(size_t i = 0; stlsoft::find_next_token(p0, p1, ';'); ++i)
		{
			printf("%u: [%d, %.*s]\n", i, p1 - p0, p1 - p0, p0);
		}}
	}

	{
		static const char	patterns[]	=	";;*.zip;*.html;;*.exe;;*.pdf;";
		char const			*p0			=	&patterns[0];
		char const			*p1			=	&patterns[0];
		char const *const	end			=	&patterns[0] + (stlsoft_num_elements(patterns) - 1);

		printf("\npatterns: %s\n", patterns);
		{ for(size_t i = 0; end != (stlsoft::find_next_token(p0, p1, end, ';')); ++i)
		{
			printf("%u: [%d, %.*s]\n", i, p1 - p0, p1 - p0, p0);
		}}
	}

	{
		static const char	patterns[]	=	"*";
		char const			*p0			=	&patterns[0];
		char const			*p1			=	&patterns[0];

		printf("\npatterns: %s\n", patterns);
		{ for(size_t i = 0; stlsoft::find_next_token(p0, p1, ';'); ++i)
		{
			printf("%u: [%d, %.*s]\n", i, p1 - p0, p1 - p0, p0);
		}}
	}

	{
		static const char	patterns[]	=	"*";
		char const			*p0			=	&patterns[0];
		char const			*p1			=	&patterns[0];
		char const *const	end			=	&patterns[0] + (stlsoft_num_elements(patterns) - 1);

		printf("\npatterns: %s\n", patterns);
		{ for(size_t i = 0; end != (stlsoft::find_next_token(p0, p1, end, ';')); ++i)
		{
			printf("%u: [%d, %.*s]\n", i, p1 - p0, p1 - p0, p0);
		}}
	}

    return 0;
}

int main(int argc, char *argv[])
{
#if 0
	::Sleep(100000);
#endif /* 0 */

	try
	{
		return main_(argc, argv);
	}
	catch(std::exception &x)
	{
		fprintf(stderr, "Unhandled error: %s\n", x.what());
	}
	catch(...)
	{
		fprintf(stderr, "Unhandled unknown error\n");
	}

	return EXIT_FAILURE;
}

/* ////////////////////////////////////////////////////////////////////////// */
