
#include <unixstl/directory_functions.hpp>
#include <unixstl/path.hpp>

#include <exception>

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
	if(argc < 3)
	{
usage:
		fprintf(stderr, "USAGE: dft {-c | -d} <root-dir> [<sub-dir-name>]\n");
		return EXIT_FAILURE;
	}
	else
	{
		char const	*op			=	argv[1];
		char const	*rootDir	=	argv[2];
		char const	*subDir		=	argv[3];
		enum Operation
		{
				createDir
			,	removeDir
		}			operation;

		if(	(operation = createDir, 0 != strcmp("-c", op)) &&
			(operation = removeDir, 0 != strcmp("-r", op)))
		{
			goto usage;
		}
		else
		{
			if( createDir == operation &&
				argc < 4)
			{
				goto usage;
			}

			try
			{
				unixstl::path	path(rootDir);

				if(NULL != subDir)
				{
					path /= subDir;
				}

				switch(operation)
				{
					case	createDir:
						fprintf(stdout, "Creating directory: %s\n", path.c_str());
						unixstl::create_directory_recurse(path.c_str());
						break;
					case	removeDir:
						fprintf(stdout, "Removing directory: %s\n", path.c_str());
						unixstl::remove_directory_recurse(path.c_str());
						break;
				}

				fprintf(stdout, "Operation succeeded\n");

				return EXIT_SUCCESS;
			}
			catch(std::exception &x)
			{
				fprintf(stderr, "Operation failed: %s\n", x.what());
				return EXIT_FAILURE;
			}
		}
	}
}

